> For the complete documentation index, see [llms.txt](https://docs.flowiseai.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.flowiseai.com/api-reference/feedback.md).

# Feedback

## List all chat message feedbacks for a chatflow

> Retrieve all feedbacks for a chatflow

```json
{"tags":[{"name":"feedback"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ChatMessageFeedback":{"type":"object","properties":{"id":{"type":"string","format":"uuid","description":"Unique identifier for the feedback"},"chatflowid":{"type":"string","format":"uuid","description":"Identifier for the chat flow"},"chatId":{"type":"string","description":"Identifier for the chat"},"messageId":{"type":"string","format":"uuid","description":"Identifier for the message"},"rating":{"type":"string","enum":["THUMBS_UP","THUMBS_DOWN"],"description":"Rating for the message"},"content":{"type":"string","description":"Feedback content"},"createdDate":{"type":"string","format":"date-time","description":"Date and time when the feedback was created"}}}}},"paths":{"/feedback/{id}":{"get":{"tags":["feedback"],"summary":"List all chat message feedbacks for a chatflow","description":"Retrieve all feedbacks for a chatflow","operationId":"getAllChatMessageFeedback","parameters":[{"in":"path","name":"id","required":true,"schema":{"type":"string"},"description":"Chatflow ID"},{"in":"query","name":"chatId","schema":{"type":"string"},"description":"Chat ID to filter feedbacks (optional)"},{"in":"query","name":"sortOrder","schema":{"type":"string","enum":["asc","desc"],"default":"asc"},"description":"Sort order of feedbacks (optional)"},{"in":"query","name":"startDate","schema":{"type":"string","format":"date-time"},"description":"Filter feedbacks starting from this date (optional)"},{"in":"query","name":"endDate","schema":{"type":"string","format":"date-time"},"description":"Filter feedbacks up to this date (optional)"}],"responses":{"200":{"description":"Successful operation","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ChatMessageFeedback"}}}}},"500":{"description":"Internal server error"}}}}}}
```

## Create new chat message feedback

> Create new feedback for a specific chat flow.

```json
{"tags":[{"name":"feedback"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ChatMessageFeedback":{"type":"object","properties":{"id":{"type":"string","format":"uuid","description":"Unique identifier for the feedback"},"chatflowid":{"type":"string","format":"uuid","description":"Identifier for the chat flow"},"chatId":{"type":"string","description":"Identifier for the chat"},"messageId":{"type":"string","format":"uuid","description":"Identifier for the message"},"rating":{"type":"string","enum":["THUMBS_UP","THUMBS_DOWN"],"description":"Rating for the message"},"content":{"type":"string","description":"Feedback content"},"createdDate":{"type":"string","format":"date-time","description":"Date and time when the feedback was created"}}}}},"paths":{"/feedback":{"post":{"tags":["feedback"],"operationId":"createChatMessageFeedbackForChatflow","summary":"Create new chat message feedback","description":"Create new feedback for a specific chat flow.","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ChatMessageFeedback"}}},"required":true},"responses":{"200":{"description":"Feedback successfully created","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ChatMessageFeedback"}}}},"400":{"description":"Invalid input provided"},"500":{"description":"Internal server error"}}}}}}
```

## Update chat message feedback

> Update a specific feedback

```json
{"tags":[{"name":"feedback"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ChatMessageFeedback":{"type":"object","properties":{"id":{"type":"string","format":"uuid","description":"Unique identifier for the feedback"},"chatflowid":{"type":"string","format":"uuid","description":"Identifier for the chat flow"},"chatId":{"type":"string","description":"Identifier for the chat"},"messageId":{"type":"string","format":"uuid","description":"Identifier for the message"},"rating":{"type":"string","enum":["THUMBS_UP","THUMBS_DOWN"],"description":"Rating for the message"},"content":{"type":"string","description":"Feedback content"},"createdDate":{"type":"string","format":"date-time","description":"Date and time when the feedback was created"}}}}},"paths":{"/feedback/{id}":{"put":{"tags":["feedback"],"summary":"Update chat message feedback","description":"Update a specific feedback","operationId":"updateChatMessageFeedbackForChatflow","parameters":[{"in":"path","name":"id","required":true,"schema":{"type":"string"},"description":"Chat Message Feedback ID"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ChatMessageFeedback"}}}},"responses":{"200":{"description":"Feedback successfully updated","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ChatMessageFeedback"}}}},"400":{"description":"Invalid input provided"},"404":{"description":"Feedback with the specified ID was not found"},"500":{"description":"Internal server error"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.flowiseai.com/api-reference/feedback.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
